
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MYSQL order by排序与索引关系总结 / 憋错料</title>

    <meta name="description" content="MYSQL order by排序与索引关系总结 MySQL InnoDB B-Tree索引使用Tips 这里主要讨论一下InnoDB B-Tree索引的使用,不提设计,只管使用.B-Tree索引主要作用于WHERE和ORDER BY子句.这里讨论的均在MySQL-Server-5.1.42测试 CREATE TABLE `friends` ( `ID` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, `uid`bigint(20) UNSIGNED NOT NULL DEFAULT '0', `fuid`">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">MYSQL order by排序与索引关系总结</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>MySQL InnoDB B-Tree索引使用Tips</h2>
<p>这里主要讨论一下InnoDB B-Tree索引的使用，不提设计，只管使用。B-Tree索引主要作用于WHERE和ORDER BY子句。这里讨论的均在MySQL-Server-5.1.42测试</p>
<pre>CREATE TABLE `friends` ( `ID` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, `uid`bigint(20) UNSIGNED NOT NULL DEFAULT ‘0‘, `fuid` bigint(20) UNSIGNED NOT NULL DEFAULT‘0‘, `fname` varchar(50) NOT NULL DEFAULT ‘‘, `fpicture` varchar(150) NOT NULL DEFAULT‘‘, `fsex` tinyint(1) NOT NULL DEFAULT ‘0‘, `status` tinyint(1) NOT NULL DEFAULT ‘0‘,PRIMARY KEY (`ID`) ) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8; ALTER TABLE`friends` ADD INDEX uid_fuid (uid, fuid);</pre>
<p><strong>1.如果索引了多列，要遵守最左前缀法则。</strong>所谓最左前列，指的是查询从索引的最左前列开始，并且不跳过索引中的列。<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQzNl80U1dpLmpwZw==.jpg" /><br />第2条语句,从索引的第二列开始查找，使用索引失败，导致MySQL采用ALL访问策略，即全表查询.在开发中，应该尽量避免全表查询。<br /><strong>2.当MySQL一旦估计检查的行数可能会&rdquo;太多&rdquo;，范围查找优化将不会被使用。</strong><br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQzN19OcURoLmpwZw==.jpg" /><br />第2条语句使用了全表查询，它与第1条语句唯一的区别在于需要检查的行数远远多于第1条语句。在应用中，可能不会碰到这么大的查询，但是应该避免这样的查 询出现: select uid from users where registered &lt; 1295001384<br /><strong>3.索引列不应该作为表达式的一部分，即也不能在索引列上使用函数</strong><br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQzN19EOTRJLmpwZw==.jpg" /><br />第2和3条语句都有使用表达式，索引派不上用场。<br /><strong>4.尽量借用覆盖索引</strong>，减少select * from &hellip;语句使用<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQzOF9jODI0LmpwZw==.jpg" /><br />第1句Extra中使用了Using index表示使用了覆盖索引。第3句也使用了覆盖索引,虽然ID不在索引uid_fuid索引列中，但是InnoDB二次索引(second index)叶子页的值就是PK值，不同于MyISAM。Extra部分的Using index表示应用了索引，不要跟type中的index混淆。第2句没有使用覆盖索引，因为fsex不在索引中。<br /><strong>5.ORDER BY子句，尽量使用Index方式排序</strong>,避免使用FileSort方式排序<br />MySQL支持二种方式的排序，FileSort和Index，后者效率高，它指MySQL扫描索引本身完成排序。FileSort方式效率较低。ORDER BY满足以下情况，会使用Index方式排序:<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;a)ORDER BY 语句使用索引最左前列。参见第1句<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;b)使用Where子句与Order BY子句条件列组合满足索引最左前列。参见第2句.<br />以下情况，会使用FileSort方式的查询</p>
<p>a)检查的行数过多，且没有使用覆盖索引。第3句，虽然跟第2句一样，order by使用了索引最左前列uid，但依然使用了filesort方式排序，因为status并不在索引中，所以没办法只扫描索引。<br />b)使用了不同的索引，MySQL每回只采用一个索引.第4句,order by出现二个索引，分别是uid_fuid和聚集索引(pk)<br />c)对索引列同时使用了ASC和DESC。 通过where语句将order by中索引列转为常量，则除外。第5句,和第6句在order by子句中，都出现了ASC和DESC排序,但是第5句却使用了filesort方式排序,是因为第6句where uid取出排序需要的数据,MySQL将其转为常量,它的ref列为const。<br />d)where语句与order by语句，使用了不同的索引。参见第7句。<br />e)where语句或者ORDER BY语句中索引列使用了表达式，包括函数表达式。参见第8，9句<br />f)where 语句与ORDER BY语句组合满足最左前缀，但where语句中使用了条件查询。查见第10句,虽然where与order by构成了索引最左有缀的条件，但是where子句中使用的是条件查询。<br />g)order by子句中加入了非索引列,且非索引列不在where子句中。<br />h)order by或者它与where组合没有满足索引最左前列。参见第11句和12句,where与order by组合，不满足索引最左前列. （uid, fsex)跳过了fuid<br />i)当使用left join，使用右边的表字段排序。参见第13句，尽管user.uid是pk，依然会使用filesort排序。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQzOV9kS1pmLmpwZw==.jpg" /><br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQ0MF9oREdCLmpwZw==.jpg" /><br /><strong>6.慎用left join语句,避免创建临时表</strong>&nbsp;使用left join语句的时候，避免出现创建临时表。尽量不要用left join，分而治之。非要使用的时候，要询问自己是不是真要必须要使用。<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQ0MV9JcGRuLmpwZw==.jpg" /><br /><strong>7.高选择性索引列</strong>。 尽量使用高选择性的过引来过滤数据。高选择性指Cardinality/#T越接近1，选择性越高，其中Cardinality指表中索引列不重复值(行)的总数。PK和唯一索引，具有最高的选择性，即1。推荐可选性达到20%以上。<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQ0Ml9pamN0LmpwZw==.jpg" /><br />这里有二个索引可供使用,而MySQL选择PRIMARY，是因为它具有更高的选择性。<br /><strong>8.谨防where子句中的OR</strong>。where语句使用or，且没有使用覆盖索引,会进行全表扫描。应该尽量避免这样OR语句。尽量使用UNION代替OR<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLm9zY2hpbmEubmV0L3VwbG9hZHMvaW1nLzIwMTMwMi8yNjEzMzQ0Ml9qZXRuLmpwZw==.jpg" /><br />第1句虽然使用了索引,但是查行时间依然不可以恭维，mysql要检查的行很多,但是返回的行却很少.Extra中的using where表示需要通过where子句扔弃不需要的数据行。<br /><strong>9.LIMIT与覆盖索引</strong>&nbsp;limit子句，使用覆盖索引时比没有使用覆盖索引会快很多</p>
<p>转自：http://my.oschina.net/longniao/blog/110384?fromerr=dKzaJdu1</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 09:31:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>MYSQL order by排序与索引关系总结的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/g41VPqM.html" rel="bookmark">mysql order by 排序的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考博客http://blog.csdn.net/hollboy/article/details/13296601 mysql order by 的排序在今天时候遇到了问题 情景是:将排序的字段设置成varchar类型了,然后排序时候并没有按从大到小的顺序 按照图中的顺序应该是正序,9排在最上边,但是实际上是666排在最上边 解决办法之一 实际情况是先按最左边的开始排序然后在一位一位比下去,这里在写sql时候的解决办法可以是加0,或者前面加上--也可以哦 解决办法之二 将字段类型换成int类型看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JAbjA3.html" rel="bookmark">MySQL order by 排序结果不正确</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新建一张测试表: CREATE TABLE `tb1` ( `id` bigint(20) NOT NULL AUTO_INCREMENT, `a` decimal(19,2) NOT NULL, `acid` bigint(20) NOT NULL, `prid` bigint(20) NOT NULL, PRIMARY KEY (`id`), KEY `idx_prid` (`prid`), KEY `idx_acid` (`acid`) ) ENGINE=InnoDB AUTO_INCRE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pPOvR4.html" rel="bookmark">MYSQL order by 排序的一个小问题探究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				小问题发现: select * from `sql` where id=1 order by (select 1 union select 2) 正常返回结果 mysql&gt; select * from `sql` where id=1 order by (select 1 union select 2); +----+------+ | id | new | +----+------+ | 1 | test | +----+------+ 1 row in set mysql&gt; select			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qKvvGM.html" rel="bookmark">mysql order by排序查询速度问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SELECT * FROM `assets_message` LEFT JOIN purchase_message ON assets_message.purchase_id = purchase_message.purchase_id WHERE `purchase_type` = 'oassets'AND purchase_message.assets_type = '002' ORDER BY purchase_message.purchase_id,assets_id SELECT *			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Omk69M.html" rel="bookmark">MySQL如何利用索引优化ORDER BY排序语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL索引通常是被用于提高WHERE条件的数据行匹配或者执行联结操作时匹配其它表的数据行的搜索速度. MySQL也能利用索引来快速地执行ORDER BY和GROUP BY语句的排序和分组操作. 通过索引优化来实现MySQL的ORDER BY语句优化: 1.ORDER BY的索引优化.如果一个SQL语句形如:SELECT [column1],[column2],…. FROM [TABLE] ORDER BY [sort];在[sort]这个栏位上建立索引就可以实现利用索引进行order by			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YYxVO0.html" rel="bookmark">MySQL中order by排序时，数据存在null咋办</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				order by排序是最常用的功能,但是排序有时会遇到数据为空null的情况,这样排序就会乱了,这里以MySQL为例,记录我遇到的问题和解决思路. 问题: 网页要实现table的行鼠标拖拽排序,我用AngularJs集成了一个TableDnD开源插件,可以实现,然后在数据库表中增加一个排序字段indexId,但是原来的大量数据是没有排序过的,所以该字段为null. 这样order by时,为null的数据就会排在最前边. 写个测试表模拟一下,如下效果: 解决办法: 最优办法:利用MySQL中的一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzNDzlM.html" rel="bookmark">MYSQL数据库表排序规则不一致导致联表查询，索引不起作用问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mysql数据库表排序规则不一致导致联表查询,索引不起作用问题 表更描述: 将mysql数据库中的worktask表添加ishaspic字段. 具体操作:(1)数据库worktask表新添是否有图片字段ishaspic:新添字段时,报错 [SQL] alter table WorkTask add ishaspic int(10) Null;[Err] 1034 - Incorrect key file for table 'WorkTask'; try to repair it 解决方案:新建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dbqK64.html" rel="bookmark">mysql order by多字段排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mysql order by多字段排序,在同一表中必须按字段顺序,否则以最后一字段的排序为准,其他无效. 如:ORDER BY `user`.`state` DESC , `user`.`order_by` ASC state字段在order_by字段前面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vWWwR4.html" rel="bookmark">MySQL order  by后对其他索引的干扰，导致优化器走错索引</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL version:5.5.36 [email protected] 5.5.36-log xxx 10:19:54&gt;show index from FD_FINANCE_ACC_HIS;+--------------------+------------+------------------------+--------------+--------------+-----------+-------------+----------+--------+------+---------			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vWOk4.html" rel="bookmark" class="title">解决kylin build cube第一步报错：java&period;lang&period;NullPointerException</a>
					<div>
						报错栈: 2017-06-19 10:27:35,757 ERROR [pool-9-thread-4] threadpool.DefaultScheduler:140 : ExecuteExcept ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYVPq0.html" rel="bookmark" class="title">配置与管理DNS服务器</a>
					<div>
						姓名:马雪敏 专业:网络工程 查看 以 bind 开头的文件 查看磁盘空间 安装镜像文件后,再次查看磁盘空间  多了1个dvd(etc/sr0) 创建一个目录 /yum 将镜像挂载到/yum目录下,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KaReY4.html" rel="bookmark" class="title">VMWARE安装H3C CAS教程！</a>
					<div>
						工具:VMware 12  下载地址:https://download3.vmware.com/software/wkst/file/VMware-workstation-full-12.5.5-52 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myjrla0.html" rel="bookmark" class="title">linux的常用命令和配置</a>
					<div>
						1.tar.gz包解压 [[email protected] crawler]# ls com.ericsson.cdm.crawler-0.0.1-SNAPSHOT-dist.tar.gz [[em ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomqKP3.html" rel="bookmark" class="title">几个面试常见算法</a>
					<div>
						1.选择排序 基本思路:选择某个索引位置的元素,然后和后面元素依次比较,若大于则交换位置,经过第一轮比较排序后可得出最小值,然后使用同样的方法把剩下的元素逐个比较即可. static void sel ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8X9z3.html" rel="bookmark" class="title">轮廓线dp &lpar;插头dp&rpar;</a>
					<div>
						轮廓线dp 骨牌覆盖问题 n和m比较小 1 #pragma comment(linker, &quot;/STACK:102400000,102400000&quot;) 2 3 #include & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvWWG4.html" rel="bookmark" class="title">&lbrack;翻译&rsqb; FBNetworkReachability</a>
					<div>
						FBNetworkReachability You can use FBNetworkReachabilty class to get network reachability on iOS devi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAQJE4.html" rel="bookmark" class="title">mongodb安装测试</a>
					<div>
						关于mongodb,就不多说了,我也来安装体验一下. mongodb安装 我安装的版本:mongodb-win32-i386-2.6.7 1.在D盘建立文件夹 d:\mogondb,创建文件夹d:\m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrERn3.html" rel="bookmark" class="title">PAT 1048&period; Find Coins</a>
					<div>
						two sum题目,算是贪婪吧 #include &lt;cstdio&gt; #include &lt;cstdlib&gt; #include &lt;vector&gt; #include &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmogR13.html" rel="bookmark" class="title">---Under Ubuntu 14&period;04</a>
					<div>
						Thinprint provides driver-free printing. Do you wish to enable this feature? [yes] Disabling timer-b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZjqv3.html" rel="bookmark" class="title">Centos7&period;2安装docker17&period;03&period;1&period;ce版本</a>
					<div>
						参考官方文档进行,地址如下: https://docs.docker.com/engine/userguide/storagedriver/device-mapper-driver/#configur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnZLP0.html" rel="bookmark" class="title">程序猿必备软件之sublimeText</a>
					<div>
						1.软件下载地址:点击打开链接 2.问题解决: (1). 中文乱码 1). 安装Sublime Package Control 2). 在Sublime Text 2上用Ctrl+-打开控制台并在里面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9WE74.html" rel="bookmark" class="title">&lbrack;WebGL入门&rsqb;十，矩阵计算和外部库</a>
					<div>
						注:文章译自http://wgld.org/,原作者杉本雅広(doxas),文章中如果有我的额外说明,我会加上［lufy:］,另外,鄙人webgl研究还不够深入,一些专业词语,如果翻译有误,欢迎大家指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbgYl3.html" rel="bookmark" class="title">Builder设计模式</a>
					<div>
						Builder设计模式:个人认为,核心在于两个类.Builder类和Director类.通过Builder类和Director类,把万事万物抽象为部件和组装两部分.通过两部分的配合,把最终的产品,展示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjEGn4.html" rel="bookmark" class="title">JavaEE基础（二十四）&sol;多线程</a>
					<div>
						1.多线程(多线程的引入) 1.什么是线程 线程是程序执行的一条路径, 一个进程中可以包含多条线程 多线程并发执行可以提高程序的效率, 可以同时完成多项工作 2.多线程的应用场景 红蜘蛛同时共享屏幕给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDD6p0.html" rel="bookmark" class="title">如何看懂IL代码--转载</a>
					<div>
						1//示例一:输出整数的立方值.  2private void PrintCube( int i )  3{  4    int cube = i * i * i;  5    Console.Wri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWde560.html" rel="bookmark" class="title">GPU异步V-Sync技术方案</a>
					<div>
						引用注明&gt;&gt; [作者:张佩][原文:www.YiiYee.cn/blog] 2014年中,我在Intel内部提交了一个名为&quot;异步Timing&quot;(又名&quot;异步V- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35p1kX0.html" rel="bookmark" class="title">FtpClient中文乱码问题解决</a>
					<div>
						原文网址:http://www.linuxidc.com/Linux/2014-10/107585.htm 最近在做文件服务器的相关东西,在原有的磁盘存储的基础上,增加了Ftp的存储方式,客户端选用的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nb29o0.html" rel="bookmark" class="title">linux中rpm 、yum详解</a>
					<div>
						一.程序包的组成: 1.底层内核:进程管理.内存管理.网络协议栈.驱动程序等 2.应用程序 :各种应用 使大家更好的通过它完成工作. 二.一个合格的程序包包含以下内容: 1.二进制程序,通常在linu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZG9yD4.html" rel="bookmark" class="title">ssh登录实现</a>
					<div>
						工程目录 配置文件详解 Spring的applicationContext.xml文件 &lt;span &gt;&lt;?xml version=&quot;1.0&quot; encoding=& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
